<template>
  <q-page class="flex flex-center">
    <div class="q-pa-md">
      <q-table
        class="table-responsive"
        title="Results"
        :data="polls"
        :columns="columns"
        row-key="tkn"
      >
        <template v-slot:body-cell-actions="props">
          <q-td :props="props">
            <q-btn
              dense
              round
              flat
              color="grey"
              @click="seeDetails(props)"
              icon="info"
            ></q-btn>
            <q-btn
              dense
              round
              flat
              color="grey"
              @click="goToVote(props)"
              icon="how_to_vote"
            ></q-btn>
          </q-td>
        </template>
      </q-table>
    </div>
  </q-page>
</template>

<script>
import { api } from "boot/axios";
const dateFormat = require("dateformat");
export default {
  name: "PageResults",
  data() {
    return {
      columns: [
        {
          name: "question",
          align: "left",
          label: "Question",
          field: "question",
          sortable: true
        },
        { name: "desc", align: "right", label: "Description", field: "desc" },
        { name: "tkn", label: "Token", field: "tkn" },
        {
          name: "startdate",
          label: "Opens",
          field: record => {
            // console.log(record.open_date);
            const close = Date.parse(record.open_date);
            // return close.toLocaleString();
            return dateFormat(close, "dd/mm/yyyy HH:MM");
          },
          sortable: true
        },
        {
          name: "enddate",
          label: "Closes",
          field: record => {
            // console.log(record.close_date);
            const close = Date.parse(record.close_date);
            // return close.toLocaleString();
            return dateFormat(close, "dd/mm/yyyy HH:MM");
          },
          sortable: true
        },
        { name: "status", label: "Status", field: "poll_status" },
        { name: "res", label: "Result", field: "result" },
        { name: "actions", label: "Actions", field: "", align: "center" }
      ],
      polls: []
    };
  },
  methods: {
    getPolls() {
      api
        .post("/api/user/getPollsVotedIn", { token: sessionStorage.token })
        .then(res => {
          this.polls = res.data.polls;
        })
        .catch(() => {
          console.log("Error retrieving polls");
        });
    },

    goToVote(props) {
      this.$router.push({ path: "/vote/" + props.key });
    },
    seeDetails(props) {
      this.$router.push({ path: "/details/" + props.key });
    }
  },
  created() {
    this.getPolls();
  }
};
</script>
